package com.maroontress.coverture.gcno;

import com.maroontress.coverture.CorruptedFileException;
import com.maroontress.coverture.Tag;
import com.maroontress.coverture.UnexpectedTagException;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.ArrayList;

/**
   ؿե쥳ɤǤ

   function_graph: announce_function basic_blocks {arcs | lines}*
*/
public final class FunctionGraphRecord {

    /** ؿΥ쥳ɤǤ */
    private AnnounceFunctionRecord announce;

    /** ܥ֥å쥳ɤǤ */
    private BasicBlockRecord blocks;

    /** ARCS쥳ɤΥꥹȤǤ */
    private ArrayList<ArcsRecord> arcs;

    /** LINES쥳ɤΥꥹȤǤ */
    private ArrayList<LinesRecord> lines;

    /**
       ХȥХåեFUNCTION_GRAPH쥳ɤϤ
       FUNCTION_GRAPH쥳ɤޤХȥХåեΰ֤
       FUNCTION_GRAPH쥳ɤƬΰ֤ǤʤФʤޤ
       ϡХȥХåեΰ֤FUNCTION_GRAPH쥳ɤμΰ
       ֤˰ưޤ

       @param bb ХȥХåե
       @throws IOException ϥ顼
       @throws CorruptedFileException եι¤Ƥ뤳Ȥ򸡽
    */
    public FunctionGraphRecord(final ByteBuffer bb)
	throws IOException, CorruptedFileException {
	announce = new AnnounceFunctionRecord(bb);
	blocks = new BasicBlockRecord(bb);
	arcs = new ArrayList<ArcsRecord>();
	lines = new ArrayList<LinesRecord>();
	while (parseArcsOrLines(bb) == 0) {
	    continue;
	}
    }

    /**
       ХȥХåեARCS쥳ɤޤLINES쥳ɤϤб
       륤󥹥󥹤ơꥹȤɲäޤХȥХåե
       ΰ֤ARCS/LINES쥳ɤƬΰ֤ǤʤФʤޤ󡣥
       ȥХåեΰ֤ARCS/LINES쥳ɤμ˿ʤߤޤ

       ХȥХåեνüϤ뤫FUNCTIONϤ-1
       ֤ޤFUNCTIONϤϥХȥХåեΰ֤
       ޤ

       @param bb ХȥХåե
       @return ARCS/LINES쥳ɤϤ0Ǥʤ-1
       @throws IOException ϥ顼
       @throws CorruptedFileException եι¤Ƥ뤳Ȥ򸡽
    */
    private int parseArcsOrLines(final ByteBuffer bb)
	throws IOException, CorruptedFileException {
	if (!bb.hasRemaining()) {
	    return -1;
	}
	int saved = bb.position();
	int tag = bb.getInt();
	switch (tag) {
	default:
	    String m = String.format("unexpected tag: 0x%x", tag);
	    throw new UnexpectedTagException(m);
	case Tag.FUNCTION:
	    bb.position(saved);
	    return -1;
	case Tag.ARCS:
	    arcs.add(new ArcsRecord(bb));
	    break;
	case Tag.LINES:
	    lines.add(new LinesRecord(bb));
	    break;
	}
	return 0;
    }

    /**
       ؿΥ쥳ɤޤ

       @return ؿΥ쥳
    */
    public AnnounceFunctionRecord getAnnounce() {
	return announce;
    }

    /**
       ܥ֥å쥳ɤޤ

       @return ܥ֥å쥳
    */
    public BasicBlockRecord getBlocks() {
	return blocks;
    }

    /**
       ARCS쥳ɤޤ

       @return ARCS쥳ɤ
    */
    public ArcsRecord[] getArcs() {
	return arcs.toArray(new ArcsRecord[arcs.size()]);
    }

    /**
       LINES쥳ɤޤ

       @return LINES쥳ɤ
    */
    public LinesRecord[] getLines() {
	return lines.toArray(new LinesRecord[lines.size()]);
    }
}
